using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using CommunityToolkit.Mvvm.ComponentModel;
using CtrEditor.FuncionesBase;
using Newtonsoft.Json;
using System.ComponentModel;


namespace CtrEditor.ObjetosSim
{
    /// <summary>
    /// Interaction logic for ucTextPlate.xaml
    /// </summary>
    /// 

    public partial class osTextPlate : osBase, IosBase
    {
        [JsonIgnore]
        public float offsetY;
        [JsonIgnore]
        public float offsetX;

        public static string NombreClase()
        {
            return "Placa de Texto";
        }

        public static string NombreCategoria()
        {
            return "Decorativos";
        }
        private string nombre = NombreClase();

        [property: Category("Identificación")]
        [property: Description("Nombre identificativo del objeto")]
        [property: Name("Nombre")]
        public override string Nombre
        {
            get => nombre;
            set => SetProperty(ref nombre, value);
        }

        [ObservableProperty]
        [property: Category("Apariencia")]
        [property: Description("Color de fondo de la placa")]
        [property: Name("Color")]
        Color color;

        [ObservableProperty]
        [property: Category("Apariencia")]
        [property: Description("Color del texto del título")]
        [property: Name("Color Título")]
        Color color_Titulo;

        [ObservableProperty]
        [property: Category("Identificación")]
        [property: Description("Texto del título")]
        [property: Name("Título")]
        string titulo;

        [ObservableProperty]
        [property: Category("Configuración")]
        [property: Description("Alto del área del título")]
        [property: Name("Alto Título")]
        public float alto_Titulo;


        public override void TopChanging(float oldValue, float newValue)
        {
            offsetY = newValue - oldValue;
        }
        public override void LeftChanging(float oldValue, float newValue)
        {
            offsetX = newValue - oldValue;
        }

        public osTextPlate()
        {
            Ancho = 0.5f;
            Alto = 0.5f;
            Alto_Titulo = 0.2f;
            Color = Colors.Gray;
            Titulo = "Titulo";
        }

        public override void ucUnLoaded()
        {
            // El UserControl se esta eliminando
            // eliminar el objeto de simulacion
        }

    }

    public partial class ucTextPlate : UserControl, IDataContainer
    {
        public osBase? Datos { get; set; }
        public int zIndex_fromFrames { get; set; }

        public ucTextPlate()
        {
            InitializeComponent();
            this.Loaded += OnLoaded;
            this.Unloaded += OnUnloaded;
        }
        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucLoaded();
        }
        private void OnUnloaded(object sender, RoutedEventArgs e)
        {
            Datos?.ucUnLoaded();
        }
        public void Highlight(bool State) { }
        public ZIndexEnum ZIndex_Base()
        {
            return ZIndexEnum.Decorativos;
        }

    }
}



